#!perl

package Dispatcher;

sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self = {};

	## Now set up data defaults
	$self->{HANDLERS} = undef;

	bless($self,$class);
	return($self);
}

sub register 
{
	my $self = shift;
	my $op = shift;
	my $class = shift;

	warn "$op is already registered to $self->{HANDLERS}{$op}\n" if exists($self->{HANDLERS}{$op});
	$self->{HANDLERS}{$op} = $class;

	return $self;
}

sub build {
	my $self = shift;
	my $op = shift;

	my $ph;

	if (exists($self->{HANDLERS}->{$op})) {
		$ph = new $self->{HANDLERS}->{$op};
	} elsif (exists($self->{HANDLERS}->{'DEFAULT'})) {
		$ph = new $self->{HANDLERS}->{'DEFAULT'};
	} else {
		## This shouldn't happen... there should always be a default handler.
		$ph = undef;
	}
	#print STDERR "Returning handler $ph for $op\n";
	return $ph;
}

1;
