#!perl

package Scraps::Client::Handler::exportsearch;

use base qw(Scraps::Client::Handler);
use Data::Dumper;

sub process
{
	my $self = shift;
	my $q = $self->get_cgi();
	my $x = $self->get_rpchandle();

	my $tmpl; 
	if(!$q->param('keywords')) {
		$tmpl = $self->get_template("simple_search_form.tmpl");
		$tmpl->param(
			op => 'exportsearch',
			script => $q->url(),
		);
		$self->{OUTPUT} = $tmpl->output();
		return;
	}	

	my $s_crit = {};
	my $data;
	
	## TODO: split keywords up as appropriate, format a search query.
	my $keywords = $q->param('keywords');
	## Now, we replace spaces in quoted keywords with ::, and
	## remove quotes.  Then, split on whitespace, then replace the :: chars with
	## whitespace.  Ugh.
	$keywords =~  s/\"([^"]+)\"/my $x = $1; $x =~ s|\s+|::|g; $x;/eg;
	@keywords = split(/\s/,$keywords);
	$s_crit->{and} = [ map { $_ =~ s/::/ /g; { keyword => $_ } } @keywords];

	eval { 
		$data = $x->call('scraps.exportSearch',$self->get_username(),$self->get_password(),{ query => $s_crit });
	};
	if($@) {
		return $self->notice($@);
	}
	
	## TODO Header should be text/xml
	$self->{HEADER} = "Content-type: text/plain\n\n";
	$self->{OUTPUT} = $data;
	return;
}

sub has_permission
{
	my $self = shift;
	## TODO: check permissions?
	$self->{PERMISSIONS}->{'all'} = 1;
	return 1;
}

1;
