#!perl

package Scraps::Client::Handler::import;

use base qw(Scraps::Client::Handler);
use Data::Dumper;

sub process
{
	my $self = shift;
	my $q = $self->get_cgi();
	my $x = $self->get_rpchandle();

	my $tmpl; 
	if(!$q->param('submit')) {
		$tmpl = $self->get_template("import_form.tmpl");
		$tmpl->param(
			'page_title' => 'Import Scraps',
			'op' => 'import',
			'script' => $q->url(),
		);
		$self->{OUTPUT} = $tmpl->output();
		return;
	}	

	## Otherwise, we should have a file.
	my $fh = $q->upload('import_file');
	my ($line,$import_data);
	my $line_count = 0;
	while(defined($line = <$fh>) && ($line_count < 1000)) {
		$import_data .= $line;	
		$line_count++;
	}

	my $result;
	eval { 
		$result = $x->call('scraps.import',$self->get_username(),$self->get_password(),$import_data);
	};
	if($@) {
		$tmpl = $self->get_template("import_form.tmpl");
		$tmpl->param(
			'page_title' => 'Import Scraps',
			'op' => 'import',
			'script' => $q->url(),
			'error_message' => $@,
		);
		$self->{OUTPUT} = $tmpl->output();
		return;
	}

	## Now, display output.
	$tmpl = $self->get_template("import_results.tmpl",1);
	$tmpl->param(
			'page_title' => 'Import Results',
			'script' => $q->url(),
			'results' => $result
	);
	$self->{OUTPUT} = $tmpl->output();
	return;

}

sub has_permission
{
	my $self = shift;
	## TODO: check permissions?
	return 1;
}

1;
