#!perl

package Scraps::Client::Handler::login;

use base qw(Scraps::Client::Handler);

sub process
{
	my $self = shift;
	my $q = $self->get_cgi();
	my $x = $self->get_rpchandle();

	my $username = $q->param('username') || undef;
	my $password = $q->param('password') || undef;

	if(!defined($username) || !defined($password)) {
		my $t =  $self->get_template("login.tmpl");
		$t->param(
			'page_title' => 'Login',
			script => $q->url()
		);
		$self->{OUTPUT} = $t->output();
		return;
	}

	## Validate username/password against scraps server.
	eval {
		$result = $x->call('scraps.user.verify',$username,$password);
	};
	if($@) {
		my $err = $@;
		$err = "Time out connecting to Scraps server" if $err =~ /Timeout/;
		$err = "Invalid username or password" if $err =~ /fault code 701/;
		my $t =  $self->get_template("login.tmpl");
		$t->param(
			'page_title' => 'Login',
			script => $q->url(),
			reason => $err
		);
		$self->{OUTPUT} = $t->output();
		return;
	}

	## Generate our cookie.
	my $cipher = new Crypt::CBC($Scraps::Client::Config::cryptkey,'Blowfish');
	$cookie = $cipher->encrypt("$username:$password");
	
	return $self->redirect(
		params => '?op=menu',
		cookie => $cookie
	);
	
}

sub has_permission
{
	my $self = shift;
	## Always have permission to log in.
	return 1;
}

1;
