#!perl

package Scraps::Client::Handler::simplesearch;

use base qw(Scraps::Client::Handler);
use Data::Dumper;

sub process
{
	my $self = shift;
	my $q = $self->get_cgi();
	my $x = $self->get_rpchandle();

	my $tmpl; 
	if(!$q->param('keywords')) {
		$tmpl = $self->get_template("simple_search_form.tmpl");
		$tmpl->param(
			page_title => 'Simple Search',
			op => 'simplesearch',
			script => $q->url(),
		);
		$self->{OUTPUT} = $tmpl->output();
		return;
	}	

	my $s_crit = {};
	
	my $keywords = $q->param('keywords');
	## Now, we replace spaces in quoted keywords with ::, and
	## remove quotes.  Then, split on whitespace, then replace the :: chars with
	## whitespace.  Ugh.
	$keywords =~  s/\"([^"]+)\"/my $x = $1; $x =~ s|\s+|::|g; $x;/eg;
	@keywords = split(/\s/,$keywords);
	$s_crit->{and} = [ map { $_ =~ s/::/ /g; { keyword => $_ } } @keywords];

	eval { 
		$list = $x->call('scraps.search',$self->get_username(),$self->get_password(),{ query => $s_crit });
	};
	if($@) {
		return $self->notice($@);
	}

	## TODO: Prepare results for display
	my $i = 0;
	foreach (@{$list}) {
		$_->{colour} = '#'.(qw(FFFFCC FFFFFF))[$i % 2];
		$i++;
	}

	$tmpl = $self->get_template("search_results.tmpl",1);
	$tmpl->param(
		page_title => 'Search Results',
		script => $q->url(),
		search_crit => $q->param('keywords'),
		results => $list 
	);
	$self->{OUTPUT} = $tmpl->output();
	return;
}

sub has_permission
{
	my $self = shift;
	## TODO: check permissions?
	$self->{PERMISSIONS}->{'all'} = 1;
	return 1;
}

1;
