#!perl

package Scraps::Client::Handler::useradd;

use base qw(Scraps::Client::Handler);
use Data::Dumper;

sub process
{
	my $self = shift;
	my $q = $self->get_cgi();
	my $x = $self->get_rpchandle();
	my $tmpl;

	if(!$q->param('submit')) {
		$tmpl = $self->get_template("useradd.tmpl");
		$tmpl->param(
			'page_title' => 'Add User',
			'op' => 'useradd',
			'script' => $q->url()
		);
		$self->{OUTPUT} = $tmpl->output();
		return;
	}

	if(!$q->param('username')) {
		return $self->notice("You must supply a username!");
	}

	if($q->param('password_one') ne $q->param('password_two')) {
		$tmpl = $self->get_template("useradd.tmpl");
		$tmpl->param(
			'page_title' => 'Add User',
			'op' => 'useradd',
			'script' => $q->url(),
			'username' => $q->param('username'),
			'error_message' => "Both passwords must be the same"
		);
		$self->{OUTPUT} = $tmpl->output();
		return;
	}

	my $data;
	eval { 
		$data = $x->call('scraps.user.add',$self->get_username(),$self->get_password(),$q->param('username'),$q->param('password_one'));
	};
	if($@) {
		return $self->notice($@);
	}
	
	$self->redirect( params => "?op=userlist");
	return;
}

sub has_permission
{
	my $self = shift;
	## TODO: check permissions?
	$self->{PERMISSIONS}->{'all'} = 1;
	return 1;
}

1;
