#!perl

package Scraps::Client::Handler::viewscrap;

use base qw(Scraps::Client::Handler);
use Data::Dumper;

sub process
{
	my $self = shift;
	my $q = $self->get_cgi();
	my $x = $self->get_rpchandle();

	my $tmpl; 
	if(!$q->param('id')) {
		return $self->notice("You can't view a scrap without a scrap ID");
	}	

	## So, we've got an ID.  Request the scrap, and then display it.
	my $scrap;
	eval { 
		$scrap = $x->call('scraps.fetchScrap',$self->get_username(),$self->get_password(),$q->param('id'));
	};
	if($@) {
		my ($errstring) = $@ =~ /fault code \d+: (.*)$/;
		return $self->notice($errstring);
	}

	## Format data according to type.
	my $data;
	if( $scrap->{data}->{type} eq 'url' ) {
		$data = qq|<a href="$scrap->{data}->{data}">$scrap->{data}->{data}</a>\n|;
	} elsif ( $scrap->{data}->{type} eq 'text' ) {
		$data = "<PRE>\n" . $scrap->{data}->{data} . "\n<PRE>\n";
	} else {
		$data = $scrap->{data}->{data};
	}

	$tmpl = $self->get_template("viewscrap.tmpl");
	$tmpl->param(
		page_title => $scrap->{title},
		script => $q->url(),
		id 	=> $scrap->{id},
		title => $scrap->{title},
		date_created => $scrap->{date}->{created} || undef,
		date_imported => $scrap->{date}->{imported} || undef,
		date_modified => $scrap->{date}->{modified} || undef,
		date_accessed => $scrap->{date}->{accessed} || undef,
		creator_name => $scrap->{creator}->{name},
		creator_email => $scrap->{creator}->{email},
		contributors => $scrap->{contributor},
		description => $scrap->{description},
		keywords => join(", ",@{$scrap->{keywords}}),
		data_data => $data,
		can_edit => $self->check_permission('edit')
	);
	$self->{OUTPUT} = $tmpl->output();
	return;
}

sub has_permission
{
	my $self = shift;
	## TODO: check permissions?
	$self->{PERMISSIONS}->{'all'} = 1;
	return 1;
}

1;
