#!/usr/bin/perl -w

use strict;
use CGI qw(:standard);
#use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;
use Dispatcher;
use Scraps::Client;
use Crypt::CBC;
use Frontier::Client;

my $q = new CGI;

## We use this for storing our username/password in the cookie.
my $cipher = new Crypt::CBC($Scraps::Client::Config::cryptkey,'Blowfish');
my $factory = new Dispatcher;
$factory->register('login',"Scraps::Client::Handler::login");
$factory->register('logout',"Scraps::Client::Handler::logout");
$factory->register('menu',"Scraps::Client::Handler::menu");
$factory->register('addscrap',"Scraps::Client::Handler::addscrap");
$factory->register('editscrap',"Scraps::Client::Handler::editscrap");
$factory->register('viewscrap',"Scraps::Client::Handler::viewscrap");
$factory->register('simplesearch',"Scraps::Client::Handler::simplesearch");
$factory->register('exportsearch',"Scraps::Client::Handler::exportsearch");
$factory->register('exportscrap',"Scraps::Client::Handler::exportscrap");
$factory->register('search',"Scraps::Client::Handler::simplesearch");
$factory->register('import',"Scraps::Client::Handler::import");
$factory->register('delete',"Scraps::Client::Handler::deletescrap");
$factory->register('password',"Scraps::Client::Handler::userpassword");
$factory->register('userlist',"Scraps::Client::Handler::userlist");
$factory->register('userdel',"Scraps::Client::Handler::userdelete");
$factory->register('useradd',"Scraps::Client::Handler::useradd");
#$factory->register('DEFAULT',"Scraps::Client::Handler::menu");

my $sv = Frontier::Client->new( url => $Scraps::Client::Config::rpcUrl);

my $cookie = $q->cookie($Scraps::Client::Config::cookieName);
my ($username,$password,$op);

if ($cookie)
{
	## If we have a cookie, extract our username from it.
	($username,$password) = split(/:/,$cipher->decrypt($cookie));
	$op = $q->param('op') || 'menu';
} else {
	$op = 'login';
}
my $page = $factory->build($op);

if(!defined($page)) {
	my $t = HTML::Template->new(
		path => [ $Scraps::Client::Config::template_dir ],
		filename => 'generic_error.tmpl'
	);
	$t->param(
		reason => "Sorry, the operation '$op' does not exist"
	);
	print $q->header();
	print $t->output();
	exit;
}
$page->set_username($username);
$page->set_password($password);
$page->set_cgi($q);
$page->set_rpchandle($sv);

if($page->has_permission) {
	$page->process();
	print $page->get_header();
	print $page->get_output();
} else {
	my $t = HTML::Template->new(
		path => [ $Scraps::Client::Config::template_dir ],
		filename => 'generic_error.tmpl'
	);
	$t->param(
		reason => "Sorry, you don't have permission to do that"
	);
	print $q->header();
	print $t->output();
	exit;
}
