#!/perl

package Scraps::Groups;

=pod 

scraps.groups.new(username, password, groupname)
	- takes <string> name of group to create.
	- returns boolean on success / fail
	- returns error if necessary:
		INVALID_AUTHENTICATION
			- username or password invalid
		INVALID_PERMISSION
			- authentication valid, but user doesn't have permission.
		INVALID_DATA
			- mandatory fields are missing from the Scrap data
		COULD_NOT_STORE
			- could not store the data on the backend b/c of some error.

=cut

sub new 
{
	my $username = shift;
	my $db = shift;
	my $group = shift;

	print Dumper $group;

}

=pod 

scraps.groups.listall(username,password)
	- returns <array> of <string> containing group names on success
	- returns errors:
		....

=cut

sub listall 
{
	my $username = shift;
	my $db = shift;

}

=pod 

scraps.groups.listmembers(username,password,groupname)
	- returns <array> of <string> containing member usernames

=cut

sub listmembers 
{
	my $username = shift;
	my $db = shift;
	my $groupname = shift;

	print Dumper $groupname;

}

=pod 

scraps.groups.adduser(username,password,group,add_username)
	- adds add_username to group
	- returns boolean true on success
	- returns appropriate error on fail:

=cut

sub adduser 
{
	my $username = shift;
	my $db = shift;
	my $group = shift;
	my $add_username = shift;

	print Dumper $group, $username;

}

=pod 
	
scraps.groups.deluser(username,password, group, del_username)
	- deletes user from group
	- returns boolean true on success
	- returns appropriate error on fail:

=cut

sub deluser 
{
	my $username = shift;
	my $db = shift;
	my $group = shift;
	my $del_username = shift;

	print Dumper $group, $username;
}

=pod 


scraps.groups.addScrap(username,password, group, scrap_id)
	- adds scrap scrap_id to the allowed scraps for group.

=cut

sub addScrap 
{
	my $username = shift;
	my $db = shift;
	my $group = shift;
	my $scrapID = shift;

	print Dumper $group, $scrapID;

}

=pod 

scraps.groups.deleteScrap(username,password, group, scrap_id)
	- removes scrap scrap_id from group

=cut

sub removeScrap 
{
	my $username = shift;
	my $db = shift;
	my $group = shift;
	my $scrapID = shift;

	print Dumper $group, $scrapID;

}

=pod 

scraps.groups.setPermissions(username, password, group, perms)
	- sets permissions of group to list in perms
	- perms is an <array> consisting of one or more of the following
	  <string>s:
	  	read
		add
		modify
		delete
		... look at MySQL perms model and see what else.  Should probably
		    keep this short, though.
	- returns true or appropriate error.

=cut

sub setPermissions 
{
	my $username = shift;
	my $db = shift;
	my $group = shift;
	my $perms = shift;

	print Dumper $group,$perms;

}

=pod 

scraps.groups.getPermissions(username, password, group)
	- returns <array> of <string> containing permissions.
	- else, on failure, returns an error.

=cut

sub getPermissions 
{
	my $username = shift;
	my $db = shift;
	my $group = shift;

	print Dumper $group;

}

1;
