#!perl

package Scraps::Util;

use Exporter;
@ISA = ('Exporter');
@EXPORT = qw(&uuidgen &generate_password &get_enum_values &get_num_hash);

=pod

=head1 Name

Scraps::Util - Exports utility functions for application to use..

=head1 Usage

=head1 Description

=head1 Methods

=over 4

=item B<uuidgen()>

This returns a scalar containing a UUID-like identifier.  This identifier is
hopefully fully-compliant with the way uuidgen(1) works, and also, fully
random.  These are probably pipe dreams, but this is good enough for our
purposes here.

=cut

##  This generates random DCE UUIDs.
##  The algorithm for this is stolen from ext2/lib/uuid/<blah>
##  in the linux kernel.
sub uuidgen
{
	my @buf;

	## Get random bytes
	for($i=0; $i<16; $i++) {
		$buf[$i] = rand(255);
	}

	## This is the only PITA left.  I haven't bothered b/c I'm too lazy to 
	## unravel the bitops required to clean it up.
	my $clock_seq = ((($buf[8] << 8) | $buf[9]) & 0x3FFF) | 0x8000;
	
	## We remove the separator dashes.
	#return sprintf("%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x",
	return sprintf("%08x%04x%04x%02x%02x%02x%02x%02x%02x%02x%02x",
		(($buf[0] << 24) | ($buf[1] << 16) | ($buf[2] << 8) | $buf[3]),
		(($buf[4] << 8) | $buf[5]),
		((($buf[6] << 8) | $buf[7] & 0x0FFF) | 0x4000),
		$clock_seq >> 8,
		$clock_seq & 0xFF,
		$buf[10],
		$buf[11],
		$buf[12],
		$buf[13],
		$buf[14],
		$buf[15]);
}

1;
